package org.eclipse.jdt.internal.compiler.codegen;

package .tmp;

import org.eclipse.jdt.internal.compiler.codegen.BranchLabel;
import org.eclipse.jdt.internal.compiler.codegen.CodeStream;

public class CaseLabel extends BranchLabel {
  public int instructionPosition = -1;
  
  public CaseLabel(CodeStream codeStream) {
    super(codeStream);
  }
  
  void branch() {
    if (this.position == -1) {
      addForwardReference(this.codeStream.position);
      this.codeStream.position += 4;
      this.codeStream.classFileOffset += 4;
    } else {
      this.codeStream.writeSignedWord(this.position - this.instructionPosition);
    } 
  }
  
  void branchWide() {
    branch();
  }
  
  public boolean isCaseLabel() {
    return true;
  }
  
  public boolean isStandardLabel() {
    return false;
  }
  
  public void place() {
    if ((this.tagBits & 0x2) != 0) {
      this.position = this.codeStream.getPosition();
    } else {
      this.position = this.codeStream.position;
    } 
    if (this.instructionPosition != -1) {
      int offset = this.position - this.instructionPosition;
      int[] forwardRefs = forwardReferences();
      for (int i = 0, length = forwardReferenceCount(); i < length; i++)
        this.codeStream.writeSignedWord(forwardRefs[i], offset); 
      this.codeStream.addLabel(this);
    } 
  }
  
  void placeInstruction() {
    if (this.instructionPosition == -1)
      this.instructionPosition = this.codeStream.position; 
  }
}
